Attribute VB_Name = "basCeaser"
Option Explicit

Const nEncodeString = 0
Const nDecodeString = 1

Const nCipherKey = 3


Public Function CeaserCipher(tcString As String, Optional tnAction As String, Optional tnCipherKey As Integer) As String

    Dim lnStrLen As Integer
    Dim lnCount As Integer
    Dim lnChar As Integer
    
    Dim lcChar As String
    Dim lcResult As String

    If IsMissing(tnAction) Then
        tnAction = nEncodeString    ' Default Action is Encoding
    End If
    
    If IsMissing(tnCipherKey) Then
        tnCipherKey = nCipherKey    ' Default CipherKey value
    End If

    If tnAction Then
        tnCipherKey = -tnCipherKey  ' If Action is encoding then the Cipher Key sign will be opposite
    End If
    
    lnStrLen = Len(tcString)
    
    For lnCount = 1 To lnStrLen
        
        lcChar = Mid(tcString, lnCount, 1)
        lnChar = Asc(lcChar)
        
        If IsAlpha(lcChar) Then ' If the character is an alphabet Encode / decode it
            
            ' To encode add the cipherkey to the asc value of the alphabet
            lnChar = lnChar + tnCipherKey
            
            ' If the result is not alphabet wrap around
            If Not IsAlpha(Chr(lnChar)) Then
                lnChar = lnChar + (-1 * Sgn(tnCipherKey) * 26)
            End If
               
        End If
        
        ' Get the encoded or decoded character
        lcChar = Chr(lnChar)
        
        lcResult = lcResult & lcChar
        
    Next
    
    CeaserCipher = lcResult
    
End Function

Public Function IsAlpha(tcChar As String) As Boolean
    ' This function will check whether the passed character is an Alphabet
    Dim lnChar As Integer
    
    lnChar = Asc(tcChar)
    IsAlpha = ((lnChar >= 65 And lnChar <= 90) Or (lnChar >= 97 And lnChar <= 122))
    
End Function
