Attribute VB_Name = "modCypher"

Const NMINRANGE As Integer = 65
Const NMAXRANGE As Integer = 90
Const NRANGE As Integer = 26

Public Function EnglishLetterFreq() As Integer()

Dim vTempFreq() As Variant
Dim nTempFreq(1 To 26) As Integer
Dim nCounter As Integer
    
    vTempFreq = Array(81, 14, 27, 38, 130, 30, 20, 52, 63, 1, 4, 34, 25, 71, 79, 19, 1, 68, 61, 105, 24, 9, 15, 2, 19, 1)
    
    For nCounter = 1 To 26
        
        nTempFreq(nCounter) = CInt(vTempFreq(nCounter - 1))
    
    Next nCounter
    
    EnglishLetterFreq = nTempFreq


End Function

Public Function LetterFreq(sInputString As String) As Integer()

Dim nTempFreq(1 To 26) As Integer
Dim nAsciCode As Integer
Dim sTempString As String

    sTempString = RemoveNilChars(sInputString)
    
    For nCounter = 1 To Len(sTempString)
        
        nAsciCode = Asc(Mid$(sTempString, nCounter, 1)) - 64
        nTempFreq(nAsciCode) = nTempFreq(nAsciCode) + 1
        
    Next nCounter
    
    LetterFreq = nTempFreq

End Function


Public Function CeasarEncrypt(sInputString As String, nKey As Integer, Optional bEncrypt As Boolean = True) As String

Dim sTempString As String
Dim nTempChar As Integer
Dim nCounter As Integer

    For nCounter = 1 To Len(sInputString)
        
        sTempString = sTempString + CeasarCodeLetter(Mid$(sInputString, nCounter, 1), nKey, bEncrypt)
        
    Next nCounter
    
    CeasarEncrypt = sTempString


End Function

Public Function PadString(ByVal sInputString As String, Optional nPadCount As Integer = 5) As String

Dim sTempString As String
Dim nTempChars As Integer
Dim nCounter As Integer

    sInputString = Trim$(UCase$(sInputString))
        
    For nCounter = 1 To (Len(sInputString)) Step nPadCount
        
        sTempString = sTempString + " " + Mid$(sInputString, nCounter, nPadCount)
        
    Next nCounter

    PadString = Trim$(sTempString)

End Function

Public Function RemoveNilChars(ByVal sInputString As String) As String

Dim sTempString As String
Dim nTempChar As Integer
Dim nCounter As Integer

    sInputString = Trim$(UCase$(sInputString))
        
    For nCounter = 1 To Len(sInputString)
        
        nTempChar = Asc(Mid$(sInputString, nCounter, 1))
        If (nTempChar >= NMINRANGE) And (nTempChar <= NMAXRANGE) Then
            sTempString = sTempString + Chr$(nTempChar)
        End If
        
    Next nCounter

    RemoveNilChars = sTempString
    

End Function


Public Function CeasarCodeLetter(sLetter As String, ByVal nKey As Integer, Optional bEncode As Boolean = True) As String

    If (bEncode = False) Then
        nKey = -(nKey)
    End If
    
    CeasarCodeLetter = Chr$(AddCharCode(AscW(sLetter), nKey))
    

End Function

Private Function AddCharCode(nAsciCode As Integer, nKey As Integer) As Integer
        
    If (nAsciCode < NMINRANGE) Or (nAsciCode > NMAXRANGE) Then
        AddCharCode = 0
        Exit Function
    End If
    
    AddCharCode = nAsciCode + nKey
    
    If (AddCharCode < NMINRANGE) Then
        AddCharCode = AddCharCode + NRANGE
    ElseIf (AddCharCode > NMAXRANGE) Then
        AddCharCode = AddCharCode - NRANGE
    End If
    
End Function

